/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const loader = __webpack_require__(/*! ./loader */ "./src/loader.js");
const plugin = __webpack_require__(/*! ./plugin */ "./src/plugin.js");
loader.Plugin = plugin;
module.exports = loader;


/***/ }),

/***/ "./src/envStore.js":
/*!*************************!*\
  !*** ./src/envStore.js ***!
  \*************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


class EnvStore {

    constructor() {
        // save envConfig
        this._envConfig = {};
        // current keys used.
        this._currentKeys = [];
    }

    addFunction(specs) {
        this._envConfig = specs.reduce((prev, config) => {
            for( let key in config){
                if (prev[key]) {
                    if(prev[key].required) {
                        config[key].required = prev[key].required;
                    }
                    if(prev[key].devRequired) {
                        config[key].devRequired = prev[key].devRequired;
                    }
                }
                return { ...prev, ...config}
            }
        }, this._envConfig)
    }

    set currentKeys(keys) {
        this._currentKeys = keys;
    }
    get envConfig() {
        return this._envConfig;
    }

    get missedKeys() {
        return Object.keys(this._envConfig).filter(key => !this._currentKeys.includes(key));
    }

    get unUsedKeys() {
        const usedKeys = Object.keys(this._envConfig);
        return this._currentKeys.filter(key => !usedKeys.includes(key));
    }

    get requiredNodeEnv() {
        return Object.keys(this._envConfig).filter(key => !!this._envConfig[key].required)
    }

    get printDetails() {
        if (this._currentKeys.length > 0) {
            const missed = this.missedKeys;
            if (missed.length > 0) {
                console.log('missed keys found');
                console.log(missed);
            }
            const unUsedKeys = this.unUsedKeys;
            if (unUsedKeys.length > 0) {
                console.log('unused keys found');
                console.log(unUsedKeys);
            }
        }
        const required = this.requiredNodeEnv;
        if (__webpack_require__("./src sync recursive").length > 0) {
            console.log('required env to set');
            console.log(required);
        }
    }
}

// Export singleton for use by loader and plugin.
module.exports = new EnvStore();

/***/ }),

/***/ "./src/getOptionsArray.js":
/*!********************************!*\
  !*** ./src/getOptionsArray.js ***!
  \********************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const { getOptions } = __webpack_require__(/*! loader-utils */ "loader-utils");
const { validate } = __webpack_require__(/*! schema-utils */ "schema-utils");

const loaderName = '@common-stack/env-list-loader';

const optionsSchema = {
    type: 'object',
    properties: {
        search: {
            anyOf: [
                {
                    instanceof: 'RegExp',
                },
                {
                    type: 'string',
                },
            ],
        },
        comment: {
            type: 'boolean',
        },
        flags: {
            type: 'string',
        },
        strict: {
            type: 'boolean',
        },
    },
    additionalProperties: false,
};

const defaultOptions = {
    search: null,
    replace: null,
    flags: null,
    strict: false,
};

function getOptionsArray(config) {
    const rawOptions = getOptions(config);
    const rawOptionsArray = typeof rawOptions.multiple !== 'undefined' ? rawOptions.multiple : [rawOptions];
    const optionsArray = [];

    for (const optionsIndex in rawOptionsArray) {
        validate(optionsSchema, rawOptionsArray[optionsIndex], { name: loaderName });

        optionsArray[optionsIndex] = Object.assign({}, defaultOptions, rawOptionsArray[optionsIndex]);
    }

    return optionsArray;
}

module.exports = getOptionsArray;


/***/ }),

/***/ "./src/loader.js":
/*!***********************!*\
  !*** ./src/loader.js ***!
  \***********************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const getOptionsArray = __webpack_require__(/*! ./getOptionsArray */ "./src/getOptionsArray.js");
const envStore = __webpack_require__(/*! ./envStore */ "./src/envStore.js");

module.exports = function (source, map) {
    this.cacheable && this.cacheable();
    const optionsArray = getOptionsArray(this);
    const cleanVersion = source
        .substring(source.indexOf('/* start */'), source.indexOf('/* end */'))
        .replace('/* start */', '')
        .trim();
    try {
        const startregex = /(?:^|\W)\(0,_envalid(?:.(str|num|json))\)(\(\{?)/g;
        const endregex = /\}?(\)\,|\}\))/g;
        const defaultRegex = /({default:.*?(\}\,))/g;
        const devDefaultRegex = /({devDefault:.*?(\}\,))/g;
        const emptyRegex = /{},/g;

        const filteredData = cleanVersion
            .replace(startregex, ':{')
            .replace(endregex, '},')
            .replace(defaultRegex, '{required: false},')
            .replace(devDefaultRegex, '{devRequired: false},')
            .replace(emptyRegex, '{required: true},');
        if (filteredData) {
            eval('var filteredObj='+filteredData);
            envStore.addFunction([{...filteredObj}]);
        }
    } catch (err) {
        console.error(err);
    }
    if(this.resource.includes('public-config')){
        const publicEnvString = source
        .substring(source.indexOf('const publicEnv=['), source.indexOf(']'))
        .replace('const publicEnv=[', '')
        .trim();
        eval('var currentKeys=['+ publicEnvString + ']');
        console.log('--- publicEnv', currentKeys)
        envStore.currentKeys = currentKeys;
        // const envKeys = Object.keys(envStore.envConfig);
        // for (const options of optionsArray) {
        //     newSource = replace(newSource, options, envKeys);
        // }
    }
    return source;
};


/***/ }),

/***/ "./src/plugin.js":
/*!***********************!*\
  !*** ./src/plugin.js ***!
  \***********************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const envStore = __webpack_require__(/*! ./envStore */ "./src/envStore.js");

// https://rohinbisht.medium.com/writing-a-custom-webpack-plugin-99126468516e
class EnvListWebpackPlugin {
    constructor(options = { } ) {
        this.processor = options.processor;
    }

    validateFile(fileName) {
        console.log('-VALIDATE', fileName);
        return /\.js$/.test(fileName);
    }

    apply(compiler) {
        compiler.hooks.done.tap('EnvListWebpackPlugin', (compilation) => {
            envStore.printDetails;
        });
    }
}

module.exports = EnvListWebpackPlugin;

/***/ }),

/***/ "./src sync recursive":
/*!*******************!*\
  !*** ./src/ sync ***!
  \*******************/
/***/ ((module) => {

function webpackEmptyContext(req) {
	var e = new Error("Cannot find module '" + req + "'");
	e.code = 'MODULE_NOT_FOUND';
	throw e;
}
webpackEmptyContext.keys = () => ([]);
webpackEmptyContext.resolve = webpackEmptyContext;
webpackEmptyContext.id = "./src sync recursive";
module.exports = webpackEmptyContext;

/***/ }),

/***/ "loader-utils":
/*!*******************************!*\
  !*** external "loader-utils" ***!
  \*******************************/
/***/ ((module) => {

"use strict";
module.exports = require("loader-utils");

/***/ }),

/***/ "schema-utils":
/*!*******************************!*\
  !*** external "schema-utils" ***!
  \*******************************/
/***/ ((module) => {

"use strict";
module.exports = require("schema-utils");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./src/index.ts");
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;
//# sourceMappingURL=index.js.map